// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'ionic-sidemenu-overlaying', 'ngCordova', 'starter.controllers', 'starter.filters', 'starter.services', /*'ionicLazyLoad', 'ionic-native-transitions',*/ 'pascalprecht.translate'])

  .run(function ($ionicPlatform, $cordovaToast, $window, $cordovaGoogleAnalytics, $localStorage, $state, $cordovaPush, $ionicHistory, $cordovaNetwork, $PrintAlert, $cordovaSplashscreen, $timeout, $rootScope, $translate, $ionicPopup, $ionicViewService, $location, $http) {

    // console.log('$localStorage.get("ArLang")',$localStorage.get("ArLang",true));
    $rootScope.MHOST = MHOST;
    $rootScope.devicePlatform = 'UNKOWN'; // init
    $rootScope.do_splash = false;
    $rootScope.notificationRedirection = false;
    $rootScope.$state = $state;

    // IMPORTANT: this part should be run before ionicPlatform.ready as some variable are used by ionic-sidemenu-overlay
    if ($localStorage.get("isNotdLang", true) == "true") {
      $translate.use('fr');
      $rootScope.current_direction = "ltr";
      $rootScope.current_class = "left";
      $rootScope.current_lang = "fr";
    } else {
      $translate.use('ar');
      $rootScope.current_direction = "rtl";
      $rootScope.current_class = "right";
      $rootScope.current_lang = "ar";
    }

    //Init Ad IDs
    admobid = {
      homeBanner: '/21671680130/BOTOLA/BOTOLA_App_Banner_ALaUne', // /21671680130/BOTOLA/BOTOLA_App_Banner_ALaUne
      newsBanner: '/21671680130/BOTOLA/BOTOLA_App_Banner_News', // /21671680130/BOTOLA/BOTOLA_App_Banner_News
      videosBanner: '/21671680130/BOTOLA/BOTOLA_App_Banner_Videos', // /21671680130/BOTOLA/BOTOLA_App_Banner_Videos
      resultatBanner: '/21671680130/BOTOLA/BOTOLA_App_Banner_Resultats', // /21671680130/BOTOLA/BOTOLA_App_Banner_Resultats
      Interstitial: '/21671680130/BOTOLA/BOTOLA_App_Interstitiel', // /21671680130/BOTOLA/BOTOLA_App_Interstitiel
      InRead: '/21671680130/BOTOLA_mobile_Innread', ///21671680130/BOTOLA_mobile_Innread
      Vast: 'https://pubads.g.doubleclick.net/gampad/live/ads?iu=/21671680130/SNRT_Player_Video/SNRT_Player_Video&env=vp&impl=s&correlator=&tfcd=0&npa=0&gdfp_req=1&output=vast&sz=400x300|640x480&cust_params=Domaine%3Dbotola_app%26support%3D', //https://pubads.g.doubleclick.net/gampad/ads?sz=640x480&iu=/124319096/external/single_ad_samples&ciu_szs=300x250&impl=s&gdfp_req=1&env=vp&output=vast&unviewed_position_start=1&cust_params=deployment%3Ddevsite%26sample_ct%3Dskippablelinear&correlator=
      License: 'mamediaads@gmail.com/9e6b0a8dac39991ad9a595309333184a'
    };

    $ionicPlatform.ready(function () {

      //Add admob fail event
      BannerFailed = function () { console.log('Banner failed loading'); admob.banner.remove(); }
      document.addEventListener("admob.banner.events.LOAD_FAIL", BannerFailed, false);


      /*********Move Splash js code here ***********/

      // Reinit history : 
      // NOTE : this is the correct place where to reinit history as the language change provokes window reload and app.js is being run again
      $localStorage.set('history', '');

      var localCheck = $localStorage.get("fav_not_set", true);

      $rootScope.do_splash = true;

      /************************ END SPLASH CODE *********/

      if (window.device) $rootScope.devicePlatform = window.device.platform;

      // This part should be initialized after the ready event as it requires 'device.platform'
      if ($localStorage.get("isNotdLang", true) == "true") {
        // force using this font in french version
        // $rootScope.bodyStyle = 'font-family: CenturyGothic !important';
        //$ionicNavBarDelegate.align('right');
      } else {
        // force using this font in arabic version
        if ($rootScope.devicePlatform == 'iOS')
          /*letter-spacing : this negative value seem to fix the space appearing in the AR version in the iOS and also Android*/
          $rootScope.bodyStyle = 'letter-spacing: -0.06em !important;';
        // else
        // $rootScope.bodyStyle = 'font-family: Cairo !important';
      }
      //Get App version number
      /*get version code stored in localstorage*/
      var version = "3";
      var savedAppVersion = localStorage.getItem("version");
      /*if there is one check if it is the same*/
      if (savedAppVersion && savedAppVersion === version) {
        // do nothing
      } else {
        /*clear all local storage*/
        localStorage.clear();
        /*save new code to ls*/
        localStorage.setItem("version", version);
      }

      // console.log('$localStorage.get("isNotdLang',$localStorage.get("isNotdLang"));
      var backbutton = 0;
      $ionicPlatform.registerBackButtonAction(function (event) {
        if ($state.current.url == '/media-detail' && $("div[data-player]").hasClass('fullscreen')) {
          console.log('back');
          $("div[data-player].fullscreen").removeClass('fullscreen');
        } else if ($state.current.url == '/favoris' || $state.current.url == '/search' || $state.current.url == '/settings' || $state.current.url == '/others/1' || $state.current.url == '/others/2' || $state.current.url == '/others/3' || $state.current.url == '/media-detail') {
          window.history.back();
        } else if ($state.current.url == '/home') {
          promptExitAppPopup($rootScope.current_lang);
        } else if ($state.current.url == '/direct-all' || $state.current.url == '/journee' || $state.current.url == '/programs') {
          $state.go('app.menu.home');
        } else if ($state.current.url == '/classement' || $state.current.url == '/buteur') {
          $state.go('app.menu.journee');
        } else if (($state.current.url == '/infos' || $state.current.url == '/videos' || $state.current.url == '/composition')) {
          if (localStorage['LinkDSource'] == 1) {
            localStorage['LinkDSource'] = 0;
            $state.go('app.menu.direct');
          } else if (localStorage['LinkSource'] == 1) {
            localStorage['LinkSource'] = 0;
            $state.go('app.menu.home');
          } else $state.go('app.menu.journee');

        } else {
          window.history.back();
        }
      }, 100);

      function promptExitAppPopup(lang) {
        if (lang == 'fr') {
          var confirmPopup = $ionicPopup.confirm({
            template: "Voulez-vous quitter l'application ?",
            cancelText: 'Non',
            okText: 'Oui',
            cancelType: 'button-positive',
            okType: 'button-positive',
          });
          confirmPopup.then(function (res) {
            if (res) {
              if (navigator.app) {
                navigator.app.exitApp();
              } else if (navigator.device) {
                navigator.device.exitApp();
              } else {
                window.close();
              }
            }
          });
        } else {
          var confirmPopup = $ionicPopup.confirm({
            title: "البطولة",
            template: "هل تريد الخروج من التطبيق ؟",
            cancelText: 'لا',
            okText: 'نعم',
            cancelType: 'button-positive',
            okType: 'button-positive',
          });
          confirmPopup.then(function (res) {
            if (res) {
              if (navigator.app) {
                navigator.app.exitApp();
              } else if (navigator.device) {
                navigator.device.exitApp();
              } else {
                window.close();
              };
            }
          });
        }
      };

      // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
      // for form inputs)
      if (window.cordova && window.cordova.plugins.Keyboard) {
        if ($rootScope.devicePlatform == 'iOS') {
          // important for select input in iOS
          cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
        } else {
          cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
        }

        cordova.plugins.Keyboard.disableScroll(true);
      }
      if (window.StatusBar) {
        // org.apache.cordova.statusbar required
        // StatusBar.styleDefault();
        //window.StatusBar.backgroundColorByHexString('#08ae3c');
      }

      //G analytics
      /*function _waitForAnalytics() {
        if (typeof window.analytics !== 'undefined') {
          $cordovaGoogleAnalytics.debugMode();
          $cordovaGoogleAnalytics.startTrackerWithId('UA-84732652-1');
          //console.log('startTrackerWithId: okok');
        } else {
          setTimeout(function() {
            _waitForAnalytics();
          }, 250);
        }
      };*/
      document.addEventListener("deviceready", function () {
        // screen.lockOrientation('portrait');
        var so = cordova.plugins.screenorientation;
        screen.orientation.addEventListener('change', function () {
          if (screen.orientation.type.startsWith('landscape')) {
            window.StatusBar.hide();
            if ($state.current.url == '/youtube-video-player') {
              $('#youtube-view').removeClass('has-header');
              $('#main_tab').hide();
            }
          } else {
            window.StatusBar.show();
            $('#youtube-view').addClass('has-header');
            $('#main_tab').show();
          }
        });

        /*so.setOrientation(5);*/
        var type = $cordovaNetwork.getNetwork();

        var isOnline = $cordovaNetwork.isOnline();

        var isOffline = $cordovaNetwork.isOffline();
        $rootScope.network_on = isOnline;
        console.log('type', type);
        var isOnline = true;
        if (window.Connection) {
          // listen for Online event
          $rootScope.$on('$cordovaNetwork:online', function (event, networkState) {
            if (isOnline) return;
            isOnline = true;
            var onlineState = networkState;
            console.log('event, networkState', event, networkState);
            $window.location.reload();
            $rootScope.network_on = true;
          });

          // listen for Offline event
          $rootScope.$on('$cordovaNetwork:offline', function (event, networkState) {
            if (!isOnline) return;
            isOnline = false;
            var offlineState = networkState;
            console.log('event, networkState', event, networkState);
            $rootScope.network_on = false;
            if ($rootScope.current_lang == 'fr') {
              $PrintAlert.Show("vous n'êtes pas connecté à internet");
            } else {
              $PrintAlert.Show("لا يوجد اتصال بالإنترنت");
            }
          });
        }
        //$cordovaSplashscreen.hide()

        console.log(window.FirebasePlugin);
        if (window.FirebasePlugin) {
          console.log('window.FirebasePlugin');
          window.FirebasePlugin.onMessageReceived(function (notification) {
            console.log('notification');
            console.log(notification);
            if (notification.tap) {
              if (notification.view) {
                if (notification.view == "app.match-detail" && notification.matchId) {
                  $rootScope.redirect_matchId = parseInt(notification.matchId);
                  $rootScope.notificationRedirection = true;
                  $state.go('app.match-detail.infos', {
                    id: parseInt(notification.matchId)
                  });
                }
                else if (notification.view == "app.media-detail" && notification.articleId) {
                  $rootScope.notificationRedirection = true;
                  var req = {
                    method: "GET",
                    url: $rootScope.HOST + "Articles/get_one.php",
                    params: { id: parseInt(notification.articleId), lang: $rootScope.current_lang },
                  };
                  $http(req).then(function (res) {
                    var articleRedirect = res.data.article;
                    $state.go('app.media-detail', { id: articleRedirect.id, type: articleRedirect.type, program: articleRedirect.program_id, match: articleRedirect.match_id });
                    //hide spinner
                    $LoadingSpinner.Hide();
                  },
                    function (error) {
                      console.log("Error Occured: ");
                      console.log(error);
                      //hide spinner
                      $LoadingSpinner.Hide();
                    });
                }
                else {
                  $state.go(notification.view);
                }
              }
            } else {
              window.simpleToastPlugin.show(notification.body, 0, function (e) {
                //$state.go(notification.view);
              }, function (e) {
                //error callback
              });
            }
            //$state.go("app.menu.results.buteur");
          }, function (error) {
            console.error(error);
          });
        }

      }, false);

      //_waitForAnalytics();

      //Main part of the code
      cordova.getAppVersion(function (version) {
        appVersion = version;
        console.info("Version: " + appVersion);
        //A ga event request should be registred here
        //registerPushNotification();
      });


      console.log($rootScope.devicePlatform);






      // var alertPopup = $ionicPopup.alert({
      //       title: $rootScope.devicePlatform,
      //       template: $rootScope.devicePlatform
      //     });
      //   alertPopup.then(function(res) {
      //       console.log('Thank you');
      //     });

      /*var androidConfig = {
        "senderID": "332099149239", //This is the project/sender ID from Google, created in Part A
        "ecb": "onAndroidNotification" //This is the function we will call when a push notification arrives. This will be detailed in the next step.
      };
  
      storedPushNotificationId = $localStorage.get("pushNotificationId", "");
      storedRegisteredAppVersion = $localStorage.get("registeredAppVersion", "");
      storedendpointArn = $localStorage.get("endpointArn", "");
      var shouldRegister = false;
  
      var registerPushNotification = function() {
        if (storedPushNotificationId == "" || storedendpointArn == "") {
          shouldRegister = true;
        } else {
          if (storedRegisteredAppVersion != appVersion) {
            shouldRegister = true;
          }
        }
  
        $cordovaPush.register(androidConfig);
        // if (shouldRegister) {
        //    console.log("Device not registred");
        //   if (device.platform == "Android") {
        //       console.log("It's an android device. Registration started...");
        //       $cordovaPush.register(androidConfig).then(function(result) {
        //         console.info('$cordovaPush.register succeeded. Result: '+ result);
        //       }, function(err) {
        //         console.info('$cordovaPush.register failed. Error: ' + err);
        //       });
        //     }
        //   }
        //End of main part of the code
      };*/

    });
  })

  .config(function ($stateProvider, $urlRouterProvider, $ionicConfigProvider, $compileProvider, $translateProvider, $provide, $httpProvider, $sceDelegateProvider) {
    $sceDelegateProvider.resourceUrlWhitelist(['self', new RegExp('^(http[s]?):\/\/(w{3}.)?youtube\.com/.+$')]);

    $provide.factory('httpInterceptor', ['$rootScope', '$q', '$injector', '$localStorage', function ($rootScope, $q, $injector, $localStorage) {
      return {
        // occurs on request
        request: function (config) {
          //Add your header to the request here
          if (!config.params) {
            config.params = {};
          }
          if ($localStorage.get("isNotdLang", true) == "true") {
            // para lang automatically passed to http request
            config.params.lang = 'fr';
          } else {
            config.params.lang = 'ar';
          }
          return config;
        }
      };
    }]);
    $httpProvider.interceptors.push('httpInterceptor');

    $translateProvider.useStaticFilesLoader({ // reference any locale-xxxxx.json locale file
      prefix: 'locale-',
      suffix: '.json'
    });
    $translateProvider.preferredLanguage('fr');
    // $translateProvider.determinePreferredLanguage(); // automatically determine best locale from browser config
    $stateProvider
      .state('app', {
        url: '/app',
        abstract: true,
        templateUrl: 'templates/menu.html',
        controller: 'AppCtrl'
      })
      .state('app.menu', {
        url: "/menu",
        views: {
          'Content': {
            templateUrl: "templates/headmenu.html",
            controller: "HeadMenuCtrl"
          }
        }
      })
      .state('app.menu.home', {
        url: "/home",
        cache: true,
        subview: false,
        /*nativeTransitions: {
          type: "fade"
        },*/
        views: {
          'home-tab': {
            templateUrl: "templates/tabs/home.html",
            controller: "HomeCtrl"
          }
        }
      })
      .state('app.menu.programs', {
        url: "/programs",
        /*nativeTransitions: {
          type: "fade"
        },*/
        subview: false,
        cache: false,
        views: {
          'programs-tab': {
            templateUrl: "templates/tabs/programs.html",
            controller: "ProgramsCtrl"
          }
        }
      })
      .state('app.direct', {
        url: "/direct",
        cache: false,
        subview: true,
        /*nativeTransitions: {
          type: "fade"
        },*/
        views: {
          'Content': {
            templateUrl: "templates/direct.html",
            controller: "DirectCtrl"
          }
        }
      })
      .state('app.menu.direct', {
        url: "/direct-all",
        cache: true,
        subview: false,
        /*nativeTransitions: {
          type: "fade"
        },*/
        views: {
          'direct-tab': {
            templateUrl: "templates/tabs/direct.html",
            controller: "DirectAllCtrl"
          }
        }
      })
      /*.state('app.menu.results', {
        url: "/results",
        cache: true,
        nativeTransitions: {
          type: "fade"
        },
        cache: true,
        views: {
          'results-tab': {
            templateUrl: "templates/tabs/results.html",
            controller: "ResultsCtrl"
          }
        }
      })*/
      .state('app.programs-details', {
        //url: "/program-detail/:program_id",
        url: "/program-detail",
        cache: false,
        subview: false,
        /*nativeTransitions: {
          type: "fade"
        },*/
        views: {
          'emission-tab': {
            templateUrl: "templates/program-details.html",
            controller: "ProgramsDetailsCtrl"
          }
        }
      })
      .state('app.programs-details.emissions', {
        url: "/emission",
        cache: true,
        subview: false,
        /*nativeTransitions: {
          type: "fade"
        },*/
        views: {
          'programs-tab': {
            templateUrl: "templates/tabs/emission.html",
            controller: "EmissionCtrl"
          }
        }
      })
      /*.state('app.programs.archive', {
        url: "/archive",
        cache: true,
        nativeTransitions: {
          type: "fade"
        },
        views: {
          'Content': {
            templateUrl: "templates/archive.html",
            controller: "ArchiveCtrl"
          }
        }
      })*/
      .state('app.menu.archive', {
        url: "/archive",
        nativeTransitions: {
          type: "fade"
        },
        cache: true,
        subview: false,
        views: {
          'programs-tab': {
            templateUrl: "templates/archive.html",
            controller: "ArchiveCtrl"
          }
        }
      })
      .state('app.menu.journee', {
        url: "/journee",
        cache: false,
        subview: false,
        /*nativeTransitions: {
          type: "fade"
        },*/
        views: {
          'results-tab': {
            templateUrl: "templates/journee.html",
            controller: "JourneeCtrl"
          }
        }
      })
      .state('app.journeenav', {
        url: "/journeenav",
        cache: false,
        subview: false,
        /*nativeTransitions: {
          type: "fade"
        },*/
        views: {
          'Content': {
            templateUrl: "templates/journeenav.html",
            controller: "JourneeCtrl"
          }
        }
      })

      .state('app.classementnav', {
        url: "/classementnav",
        cache: false,
        subview: false,
        /*nativeTransitions: {
          type: "fade"
        },*/
        views: {
          'Content': {
            templateUrl: "templates/classementnav.html",
            controller: "ClassementCtrl"
          }
        }
      })

      .state('app.buteurnav', {
        url: "/journeenav",
        cache: false,
        subview: false,
        /*nativeTransitions: {
          type: "fade"
        },*/
        views: {
          'Content': {
            templateUrl: "templates/buteurnav.html",
            controller: "ButeurCtrl"
          }
        }
      })

      /*.state('app.menu.classement', {
        url: "/classement",
        cache: true,
        nativeTransitions: {
          type: "fade"
        },
        views: {
          'results-tab': {
            templateUrl: "templates/classement.html",
            controller: "ClassementCtrl"
          }
        }
      })*/
      .state('app.menu.classement', {
        url: "/classement",
        cache: true,
        subview: false,
        /*nativeTransitions: {
          type: "fade"
        },*/
        views: {
          'results-tab': {
            templateUrl: "templates/classement.html",
            controller: "ClassementCtrl"
          }
        }
      })
      .state('app.menu.buteur', {
        url: "/buteur",
        cache: true,
        subview: false,
        /*nativeTransitions: {
          type: "fade"
        },*/
        views: {
          'results-tab': {
            templateUrl: "templates/buteur.html",
            controller: "ButeurCtrl"
          }
        }
      })
      .state('app.match-detail', {
        url: "/match-detail/:id",
        /*nativeTransitions: {
          type: "fade"
        },*/
        cache: false,
        subview: true,
        views: {
          'Content': {
            templateUrl: "templates/match-detail.html",
            controller: "MatchDetailCtrl"
          }
        }
      })
      .state('app.match-detail.infos', {
        url: "/infos",
        cache: false,
        subview: true,
        /*nativeTransitions: {
          type: "fade"
        },*/
        views: {
          'infos-tab': {
            templateUrl: "templates/match-infos.html",
            controller: "MatchInfosCtrl"
          }
        }
      })
      .state('app.match-detail.videos', {
        url: "/videos",
        cache: false,
        subview: true,
        /*nativeTransitions: {
          type: "fade"
        },*/
        views: {
          'videos-tab': {
            templateUrl: "templates/match-videos.html",
            controller: "MatchVideosCtrl"
          }
        }
      })
      .state('app.match-detail.composition', {
        url: "/composition",
        cache: false,
        subview: true,
        /*nativeTransitions: {
          type: "fade"
        },*/
        views: {
          'composition-tab': {
            templateUrl: "templates/match-composition.html",
            controller: "MatchCompositionCtrl"
          }
        }

      })
      .state('app.search', {
        url: "/search",
        cache: false,
        subview: true,
        views: {
          'Content': {
            templateUrl: "templates/search-results.html",
            controller: "SearchCtrl"
          }
        }
      })
      .state('app.menu.more-articles', {
        url: "/more-articles",
        cache: true,
        subview: false,
        views: {
          'direct-tab': {
            templateUrl: "templates/more-articles.html",
            controller: "ArticlesCtrl"
          }
        }
      })
      .state('app.media-detail', {
        url: "/media-detail/:id/:type/:program/:match",
        cache: false,
        subview: true,
        views: {
          'Content': {
            templateUrl: "templates/media-detail.html",
            controller: "MediaDetailCtrl"
          }
        }
      })
      .state('app.youtube-video-player', {
        url: "/youtube-video-player",
        cache: true,
        subview: true,
        views: {
          'Content': {
            templateUrl: "templates/youtube-video-player.html",
            controller: "YoutubeVideoPlayerCtrl"
          }
        }
      })
      /*.state('app.downloads', {
        url: "/downloads",
        views: {
          'Content': {
            templateUrl: "templates/downloads.html",
            controller: "DownloadsCtrl"
          }
        }
      })*/
      /*state('app.local-media', {
        url: "/local-media",
        views: {
          'Content': {
            templateUrl: "templates/local-media.html",
            controller: "LocalMediaDetailCtrl"
          }
        }
      })*/
      .state('select-favoris', {
        url: "/select-favoris/:changeSession",
        cache: true,
        subview: true,
        /*nativeTransitions: {
          type: "fade"
        },*/
        templateUrl: "templates/select-favoris.html",
        controller: "SelectFavorisCtrl"
      })
      .state('app.settings', {
        url: "/settings",
        cache: true,
        subview: true,
        views: {
          'Content': {
            templateUrl: "templates/settings.html",
            controller: "SettingsCtrl"
          }
        }

      })
      .state('app.mentions', {
        url: "/others/:param",
        cache: true,
        subview: true,
        views: {
          'Content': {
            templateUrl: "templates/others.html",
            controller: "OthersCtrl"
          }
        }
      })
      .state('splash', {
        url: "/splash",
        cache: true,
        subview: false,
        /*nativeTransitions: {
          type: "fade"
        },*/
        templateUrl: "templates/splash.html",
        controller: "SplashCtrl"

      })
      .state('tutorial', {
        url: "/tutorial",
        cache: true,
        subview: true,
        /*nativeTransitions: {
          type: "fade"
        },*/
        templateUrl: "templates/tutorial.html",
        controller: "TutorialCtrl"

      })
      .state('langchoice', {
        url: "/langchoice",
        cache: true,
        /*nativeTransitions: {
          type: "fade"
        },*/
        templateUrl: "templates/langchoice.html",
        controller: "LangchoiceCtrl"

      });

    /*************SPLASH CODE MOVED HERE ****************/
    //check if tutorial ui been already seen
    if (localStorage['tutorialSeen'] == "true") {

      // $state.go('app.menu.home');
      $urlRouterProvider.otherwise('/app/menu/home');
    }
    else {
      //go to lang choice
      $urlRouterProvider.otherwise('/langchoice');

    }

    /****************************  END SPLASH CODE ***************/

    $ionicConfigProvider.views.maxCache(5);
    $ionicConfigProvider.views.forwardCache(false);
    $ionicConfigProvider.scrolling.jsScrolling(false);
    $compileProvider.debugInfoEnabled(false);
  })
  .filter('iif', function () {
    return function (input, trueValue, falseValue) {
      return input ? trueValue : falseValue;
    };
  })
  .filter("htmlSafe", ['$sce', function ($sce) {
    return function (htmlCode) {
      return $sce.trustAsHtml(htmlCode);
    };
  }]);
