angular.module('starter.controllers', [])

    .controller('AppCtrl', function ($scope, $ionicHistory, $ionicSideMenuDelegate, $rootScope, $ionicModal, $timeout, $LoadingSpinner, $http, $UserAuth, $state, $cordovaGoogleAnalytics, $window, $localStorage, $translate, $ionicPopover) {

        //Init HOST
        $rootScope.HOST = MHOST;

        /**
         * Summary. Init previous saison
         */
        $scope._InitOldSaison = function () {
            var req = {
                method: "GET",
                url: $rootScope.HOST + "ALaUne/",
                params: { resolution: $window.innerWidth },
            };
            $http(req).then(function (res) {
                console.log(res.data.OLD_SAISON_STATUS);
                //Update old saison ID + it s status
                $rootScope.OLD_SAISONS = res.data.OLD_SAISONS;
            });
        }

        //Init old saison 
        $scope._InitOldSaison();

        //Open Previous saison
        $scope.openPreviousSaison = function (OLD_SAISON_ID) {
            if (OLD_SAISON_ID) {
                //Init old saison id
                $rootScope.saisonId = OLD_SAISON_ID;
                //Go to journee
                $state.go('app.journeenav', {}, {reload: true});
            }
        }

        /**********Init banner & interstitial ads */
        //No Admob onload callback available, so we need to add a manual setimeout
        $scope.InitNativeAds = function () {
            $timeout(function () {
                if (typeof AdMob != "undefined") {
                    console.log(AdMob);
                    console.log('Admob is ready!');
                    $scope.StartNativeAds();
                }
                else {
                    // console.log('Wait for another 1s');
                    $scope.InitNativeAds();
                }
            }, 1000);
        }

        $scope.StartNativeAds = function () {
            // preppare and load ad resource in background, e.g. at begining of game level
            // AdMob.prepareInterstitial({ adId: admobid.Interstitial, autoShow: true, isTesting: false, license: admobid.License });
            admob.interstitial.config({
                id: admobid.Interstitial,
            });

            admob.interstitial.prepare();

            admob.interstitial.show();
        }

        //Init native ads
        $scope.InitNativeAds();

        /**********Init PopOver template *******/
        $ionicPopover.fromTemplateUrl('templates/popover.html', {
            scope: $scope,
        }).then(function (popover) {
            $scope.popover = popover;
        });

        /* ----------------------------------------
         *            HSITORY UTILS
         * ----------------------------------------*/

        $rootScope.$on('$stateChangeSuccess', function (event, to, toParams, from, fromParams) {
            $rootScope.$previousState = from;
            $rootScope.$previousState.params = fromParams;
            $rootScope.$previousState.to = {
                name: to.name,
                subview: to.subview
            };
            if (!to.subview) {
                $localStorage.set('history', ''); // erase history here
            }
            console.log('from')
            console.log(from)
            console.log('to')
            console.log(to)
        });

        $rootScope.history = {};
        $rootScope.history.get = function () {
            return $localStorage.get('history', '');;
        }
        $rootScope.history.add = function (previousView, currentView) {
            /*if($rootScope.currentView != null && view.name == $rootScope.currentView.name){
              $rootScope.currentView = currentView;
              return;
            }*/
            var history = $localStorage.get('history', '');
            history = (history != '') ? JSON.parse(history) : [];

            if (previousView == null) return;

            // ignore history in-between match-details tabs, or it may lead to a lot of bugs
            if (previousView.name == 'app.match-detail.infos' || previousView.name == 'app.match-detail.videos' || previousView.name == 'app.match-detail.composition')
                if (currentView.name == 'app.match-detail.infos' || currentView.name == 'app.match-detail.videos' || currentView.name == 'app.match-detail.composition')
                    return;

            // fix for match-detail youtube-video
            if (previousView.name == 'app.youtube-video-player')
                if (previousView.to.name == 'app.match-detail.infos' || previousView.to.name == 'app.match-detail.videos' || previousView.to.name == 'app.match-detail.composition')
                    return;

            //if(previousView.subview && currentView.subview) return; // do not handle history in between subviews
            if (previousView.name == $localStorage.get('history_lastClosedView', '')) {
                $localStorage.set('history_lastClosedView', '');
                return; // fix endless loop
            }

            var inHistory = false;
            history.forEach(function (view, idx) {
                if (view.name == previousView.name || view.name == currentView.name) {
                    inHistory = true;
                    return;
                }
            });
            if (inHistory) return;
            history.push(previousView)
            console.log(history);

            $localStorage.set('history', JSON.stringify(history));
            $rootScope.currentView = currentView;
        }


        $rootScope.history.back = function () {
            var history = $localStorage.get('history', '');
            history = (history != '') ? JSON.parse(history) : [];

            if (history.length > 0) {
                view = history[history.length - 1]
                history.pop();
                if (view.subview) {
                    $localStorage.set('history_lastClosedView', view.to.name);
                }
                $localStorage.set('history', JSON.stringify(history));
                $state.go(view.name, view.params);
            } else {
                // if no history
                $state.go('app.menu.home');
            }
        };

        $rootScope.$ionicGoBack = function (backCount) {
            $rootScope.history.back();
        };

        //SetInterval Initiators
        $rootScope.IntervalMatchDetail = false;
        $rootScope.IntervalDirect = false;
        $rootScope.IntervalHome = false;

        //Update menu teams
        var str = "";
        str = localStorage['fav-team'];
        //Update menu teams
        if (str) $rootScope.favoris_teams = str.split(';');

        $rootScope.CheckGanal = function (func) {
            if (typeof window.analytics !== 'undefined') {
                func();
                //console.log('Func EXEC OK');
            } else {
                setTimeout(function () {
                    $scope.CheckGanal(func);
                }, 250);
            }
        }
        //$cordovaGoogleAnalytics.startTrackerWithId("UA-84732652-1");

        // With the new view caching in Ionic, Controllers are only called
        // when they are recreated or on app start, instead of every page change.
        // To listen for when this page is active (for example, to refresh data),
        // listen for the $ionicView.enter event:
        //$scope.$on('$ionicView.enter', function(e) {
        //});

        $rootScope.playOnYoutube = function (video_id) {
            //if ($rootScope.devicePlatform == 'Android')
            // YoutubeVideoPlayer.openVideo(video_id);

            window.InAppYouTube.openVideo(video_id, {
                fullscreen: true
            }, function (result) {
                // console.log(JSON.stringify(result));
            }, function (reason) {
                // console.log(reason);
            });

            //else {
            // this is mainly for iOS
            //        $rootScope.currentYoutubeVideo = video_id;
            //  $state.go('app.youtube-video-player');
            //}
        }
        //Get Last Sync
        if ($UserAuth.GetLastSync()) $rootScope.lastSync = $UserAuth.GetLastSync();

        //ChangeLang
        $rootScope.ChangeLang = function () {
            //Show spinner
            $LoadingSpinner.Show();

            //init lang
            lang = $rootScope.current_lang;
            //Switch lang
            if ($rootScope.current_lang == "fr") $rootScope.current_lang = "ar";
            else $rootScope.current_lang = "fr";

            var favteam = localStorage['fav-team'];
            var favoris_teams = [];
            if (favteam != undefined) {
                favoris_teams = favteam.split(';');
            }

            $topic_lang_postfix = ($rootScope.current_lang == 'ar') ? '_AR' : '';

            var notifs_settings = $localStorage.getObject("notifs_settings", {
                noficationStatus: true,
                noficationStatus_weekStart: true,
                noficationStatus_gameStart: true,
                noficationStatus_gameEnd: true,
                noficationStatus_goals: true,
                noficationStatus_redCard: true,
                noficationStatus_yellowCard: true
            });

            //Check if firebase service is available
            if (window.FirebasePlugin) {
                if ($rootScope.current_lang == "fr") {
                    //Check beta version flag
                    if (!BetaFlag) {
                        console.log('Disable TEST_ALL & TEST_ALL_AR & ALL_AR => Subscribe to ALL');
                        window.FirebasePlugin.subscribe("ALL");
                        //Unsubscribe from all test topics
                        window.FirebasePlugin.unsubscribe('TEST_ALL');
                        window.FirebasePlugin.unsubscribe('TEST_ALL_AR');
                        //Unsubscribe from all prod topics
                        window.FirebasePlugin.unsubscribe('ALL_AR');
                    }
                    else {
                        console.log('Disable ALL & ALL_AR & TEST_ALL_AR => Subscribe to TEST_ALL');
                        window.FirebasePlugin.subscribe('TEST_ALL');
                        //Unsubscribe from all prod topics
                        window.FirebasePlugin.unsubscribe('ALL');
                        window.FirebasePlugin.unsubscribe('ALL_AR');
                        //Unsubscribe from all test topics
                        window.FirebasePlugin.unsubscribe('TEST_ALL_AR');
                    }
                }
                else {
                    //Check beta version flag
                    if (!BetaFlag) {
                        console.log('Disable TEST_ALL & TEST_ALL_AR & ALL => Subscribe to ALL_AR');
                        window.FirebasePlugin.subscribe("ALL_AR");
                        //Unsubscribe from all test topics
                        window.FirebasePlugin.unsubscribe('TEST_ALL');
                        window.FirebasePlugin.unsubscribe('TEST_ALL_AR');
                        //Unsubscribe from all prod topics
                        window.FirebasePlugin.unsubscribe('ALL');
                    }
                    else {
                        console.log('Disable ALL & ALL_AR & TEST_ALL => Subscribe to TEST_ALL_AR');
                        window.FirebasePlugin.subscribe('TEST_ALL_AR');
                        //Unsubscribe from all prod topics
                        window.FirebasePlugin.unsubscribe('ALL');
                        window.FirebasePlugin.unsubscribe('ALL_AR');
                        //Unsubscribe from all test topics
                        window.FirebasePlugin.unsubscribe('TEST_ALL');
                    }
                }

                favoris_teams.forEach(function (favTeamId) {
                    console.log(favTeamId);
                    $topic_lang_postfix_reverse = $topic_lang_postfix == '_AR' ? '' : '_AR';

                    // subscribe again
                    if (favTeamId != '') {// valid team Id
                        if (notifs_settings.noficationStatus_gameStart)
                            window.FirebasePlugin.subscribe(TopicFlag + "TEAM_" + favTeamId + '_GAME_START' + $topic_lang_postfix);

                        if (notifs_settings.noficationStatus_gameEnd)
                            window.FirebasePlugin.subscribe(TopicFlag + "TEAM_" + favTeamId + '_GAME_END' + $topic_lang_postfix);

                        if (notifs_settings.noficationStatus_goals)
                            window.FirebasePlugin.subscribe(TopicFlag + "TEAM_" + favTeamId + '_GOAL' + $topic_lang_postfix);

                        if (notifs_settings.noficationStatus_yellowCard) {
                            window.FirebasePlugin.subscribe(TopicFlag + "TEAM_" + favTeamId + '_YELLOW_CARD' + $topic_lang_postfix);
                        }

                        if (notifs_settings.noficationStatus_redCard)
                            window.FirebasePlugin.subscribe(TopicFlag + "TEAM_" + favTeamId + '_RED_CARD' + $topic_lang_postfix);

                        // unsubsribe from all
                        window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_GAME_START' + $topic_lang_postfix_reverse);
                        window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_GAME_END' + $topic_lang_postfix_reverse);
                        window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_GOAL' + $topic_lang_postfix_reverse);
                        window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_YELLOW_CARD' + $topic_lang_postfix_reverse);
                        window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_RED_CARD' + $topic_lang_postfix_reverse);
                    }
                });
            }

            if (lang == 'fr') {
                $localStorage.set("isNotdLang", false);
                // $translate.use('ar');
            } else {
                $localStorage.set("isNotdLang", true);
                // $translate.use('fr');
            }
            setTimeout(function () {
                //this reload apprently is mondatory to fix a sliding menu issue
                $window.location.reload();
            }, 500);
        }
        //Init Sync
        $rootScope.CurrentSync = function () { };

        $scope.Sync = function () {
            //Get new Sync
            // $rootScope.lastSync = $UserAuth.GetNewSync();
            // console.log($state.current.url);
            if ($state.current.url == "/home") $rootScope._InitHome(true);
            if ($state.current.url == "/emission") $rootScope._InitEmissions();
            if ($state.current.url == "/direct-all") $rootScope._InitLiveAll(true);
            if ($state.current.url == "/archive") $rootScope._InitArchive();
            if ($state.current.url == "/journee") $rootScope._InitJournee();
            if ($state.current.url == "/results") $rootScope._InitJournee();
            if ($state.current.url == "/classement") $rootScope._InitClassement();
            if ($state.current.url == "/buteur") $rootScope._InitButeur();
            if ($state.current.url == "/infos") $rootScope._InitMatchDetail(true);
            if ($state.current.url == "/videos") $rootScope._InitMatchVideos();
            if ($state.current.url == "/favoris") $rootScope._InitFavorites();
            if ($state.current.url == "/programs") $rootScope._InitEmissions();
        }

        $scope.LaunchSite = function () {
            window.open('http://botola.snrt.ma', '_system');
            $scope.popover.hide();
        }

    });