angular.module('starter')

  .controller('HomeCtrl', function ($scope, $state, $window, $localStorage, $http,
    $LoadingSpinner, $stateParams, $rootScope, $PrintAlert, $Tools, $sce, $cordovaGoogleAnalytics, $timeout) {

    //Init data
    $scope.data = {
      todayMatchsLive: []
    }

    $scope.vidsensHeight = $window.innerWidth * 0.5625;

    $scope.switchRight = function () {
      if ($scope.current_lang == 'fr') $scope.slider.slideNext();
      else $scope.slider.slidePrev();
    }

    $scope.switchLeft = function () {
      if ($scope.current_lang == 'fr') $scope.slider.slidePrev();
      else $scope.slider.slideNext();
    }

    $scope.slider_options = {
      loop: true,
      autoplay: 3000
    }

    $scope.$on("$ionicSlides.sliderInitialized", function (event, data) {
      // data.slider is the instance of Swiper
      $scope.slider = data.slider;
      console.log(data);
    });

    $scope.$on("$ionicSlides.slideChangeEnd", function (event, data) {
      // note: the indexes are 0-based
      if ($scope.slider) $scope.slider.startAutoplay();
    });

    //Go to current journey
    $scope.GotoCurrentJourney = function () {
      //this is a BOTOLA match => needs a journey redirection
      $rootScope.CurrentJourney = $rootScope.ServerCurrentJourney;
      $state.go('app.menu.journee');
    }
    //go to specific journey => could be done using routes => statsparam but needs a bit of time for adapting journees navigation
    $scope.GotoJourney = function (match) {
      //check match's type
      if (match.type != 'BOTOLA') {
        $rootScope.match = match;
        $state.go('app.match-detail.composition', { id: $rootScope.match.id });
      }
      else {
        //this is a BOTOLA match => needs a journey redirection
        $rootScope.CurrentJourney = match.journee;
        $state.go('app.menu.journee');
      }

    }
    //go to match detail
    $scope.MatchDetail = function (item) {
      //Mark Home as source link
      localStorage['LinkSource'] = 1;

      $rootScope.match = item;
      $state.go('app.match-detail.infos', { id: $rootScope.match.id });
    }

    $scope.goToVideoPlus = function () {
      $state.go('app.menu.programs');
    };

    $rootScope._InitHome = function (passthrough) { //passthrough = false not supported
      //check if there are some live matchs
      if ($state.current.url == '/home' && ($scope.data.todayMatchsLive.length > 0 || passthrough)) {
        console.log('_InitHome');
        $LoadingSpinner.Show();
        //$rootScope.CheckGanal(function() { $cordovaGoogleAnalytics.trackView('A la une') });
        var req = {
          method: "GET",
          url: $rootScope.HOST + "ALaUne/",
          params: { resolution: $window.innerWidth },
        };
        $http(req).then(function (res) {
          //Init data
          $scope.data = res.data;

          //Update old saison ID + it s status
          // $rootScope.OLD_SAISON_YEAR = res.data.OLD_SAISON_YEAR;
          // $rootScope.OLD_SAISON_ID = res.data.OLD_SAISON_ID;
          // $rootScope.OLD_SAISON_STATUS = res.data.OLD_SAISON_STATUS;


          //broadcast refresh end
          $scope.$broadcast('scroll.refreshComplete');
          //hide spinner
          $LoadingSpinner.Hide();

          //Check if saison has changed
          if (res.data.saisonId != localStorage["local_saison"] && localStorage['tutorialSeen']) {
            //Update local saison
            localStorage["local_saison"] = res.data.saisonId;

            //Go to favorite team
            $state.go('select-favoris', {changeSession: true});
          }
          else {
            //Init ads
            $scope.InitNativeAds();
            $scope.InitPaveAds();
          }

          //Check if firebase tech is avaialble
          if (window.FirebasePlugin) window.FirebasePlugin.setScreenName("A la une"); 1

          //switch tutorialSeen flag
          localStorage['tutorialSeen'] = "true";
        },
          function (error) {
            console.log("Error Occured: ");
            console.log(error);
            //broadcast refresh end
            $scope.$broadcast('scroll.refreshComplete');
            //hide spinner
            $LoadingSpinner.Hide();
          });
      }
    }

    $scope.Detail = function (item) {
      $rootScope.item = item;
      console.log(item);
      // $scope.playOnYoutube(item.video_id);
      $state.go('app.media-detail', { id: $rootScope.item.id, type: $rootScope.item.type, program: $rootScope.item.program_id, match: $rootScope.item.match_id });
    }

    $scope.PlayOnYoutube = function (item) {
      item.type = 2;
      $rootScope.item = item;
      // $state.go('app.media-detail');
      $rootScope.playOnYoutube(item.video_id);
    }


    //start setInterval timer
    if (!$rootScope.IntervalHome) {
      setInterval($rootScope._InitHome, 60000);
      $rootScope.IntervalHome = true;
    }

    $scope.doRefresh = function () {
      $rootScope._InitHome(true);
    }

    var addZero = function (i) {
      if (i < 10) {
        i = "0" + i;
      }
      return i;
    }

    $scope.gettime = function (date) {
      return addZero(new Date(date).getHours()) + ":" + addZero(new Date(date).getMinutes());
    }
    $scope.fullranking = function () {
      $state.go('app.menu.classement');
    }

    $scope.GoLive = function (item, index) {
      console.log(item);
      console.log(admobid.Vast + item.label + '&unviewed_position_start=1');
      //Mark Home as source link
      localStorage['LinkSource'] = 1;
      if (item.live_id) {
        $rootScope.item = item;
        $rootScope.live_id = item.live_id;
        // $state.go('app.direct');
        //Start StreamingMediaIMA
        window.StreamingMediaIMA.playVideo(item.url, {
          adTagUrl: admobid.Vast + item.label + '&unviewed_position_start=1'
        });
      } else {
        $rootScope.match = item;
        $rootScope.FilesPath = $scope.data.FilesPath;
        $state.go('app.match-detail.infos', { id: $rootScope.match.id });
      }
    }

    $scope.Search = function (key) {
      // > Test live stream
      //$rootScope.live_id = 8;
      //$state.go('app.direct');

      $rootScope.keyword = key;
      $state.go("app.search");
    }


    $scope.InitNativeAds = function () {
      $timeout(function () {
        if (typeof admob != "undefined") {
          console.log(admob);
          console.log('Admob is ready!');
          $scope.StartNativeAds();
        }
        else {
          // console.log('Wait for another 1s');
          $scope.InitNativeAds();
        }
      }, 1000);
    }

    $scope.InitPaveAds = function () {
      //check if home tags are already displayed
      if (window['home_tags']) {
        window['googletag'].pubads().refresh([window['gptAdSlots'][0]]);
        window['googletag'].pubads().refresh([window['gptAdSlots'][4]]);
        window['googletag'].pubads().refresh([window['gptAdSlots'][5]]);
        window['googletag'].pubads().refresh([window['gptAdSlots'][6]]);
      }
      else {
        $timeout(function () {
          window['home_tags'] = true;
          window['googletag'].cmd.push(function () {
            window['googletag'].display('div-gpt-ad-1515432416448-0');
            window['googletag'].display('div-gpt-ad-1515432416448-4');
            window['googletag'].display('div-gpt-ad-1515432416448-5');
            window['googletag'].display('div-gpt-ad-1515432416448-6');

            window['googletag'].pubads().refresh([window['gptAdSlots'][0]]);
            window['googletag'].pubads().refresh([window['gptAdSlots'][4]]);
            window['googletag'].pubads().refresh([window['gptAdSlots'][5]]);
            window['googletag'].pubads().refresh([window['gptAdSlots'][6]]);
          });
        }, 100);
      }
    }

    $scope.StartNativeAds = function () {
      // display smart banner at bottom center, using the default options
      //Clear old banner if any
      admob.banner.remove();
      //Config banner id
      admob.banner.config({
        id: admobid.homeBanner,
      });
      // Create banner
      admob.banner.prepare();
      // Show the banner
      admob.banner.show();

    }

    /**
     * Summary. Firebase init op should be moved here, when the user chooses the fr lang, notifs are already registred with arabic lang
     */
    $scope._InitFirebase = function () {
      var firebase_registred_topics = $localStorage.get("FIREBASE_REGISTRED_TOPICS_V8", false);
      // if (!firebase_registred_topics) {
      if (window.FirebasePlugin) {

        if ($rootScope.devicePlatform == 'iOS') {
          window.FirebasePlugin.grantPermission();
        }
        //window.FirebasePlugin.setConfigSettings(settings);

        //FCMPlugin.getToken( successCallback(token), errorCallback(err) );
        //Keep in mind the function will return null if the token has not been established yet.
        window.FirebasePlugin.getToken(function (token) {
          console.log('token_HOME_UI', token);
          // save this server-side and use it to push notifications to this device

          //Subscribe to the main topic
          window.FirebasePlugin.subscribe('BOTOLA_MAIN_TOPIC');
          //Unsubscribe from all test topics
          // window.FirebasePlugin.unsubscribe('TEST_ALL');
          // window.FirebasePlugin.unsubscribe('TEST_ALL_AR');

          //Unsubscribe from all prod topics
          // window.FirebasePlugin.unsubscribe('ALL');
          // window.FirebasePlugin.unsubscribe('ALL_AR');

          if ($rootScope.current_lang == "fr") {
            console.log("FRENCH SUBSCRIPION", !BetaFlag, window.FirebasePlugin);
            //Check beta version flag
            if (!BetaFlag) window.FirebasePlugin.subscribe("ALL");
            else window.FirebasePlugin.subscribe('TEST_ALL');
          }
          else {
            console.log("ARABIC SUBSCRIPION", !BetaFlag, window.FirebasePlugin);
            //Check beta version flag
            if (!BetaFlag) window.FirebasePlugin.subscribe("ALL_AR");
            else window.FirebasePlugin.subscribe('TEST_ALL_AR');
          }

          var favteam = localStorage['fav-team'];
          var favoris_teams = [];
          if (favteam != undefined) {
            favoris_teams = favteam.split(';');
          }

          $topic_lang_postfix = ($rootScope.current_lang == 'ar') ? '_AR' : '';

          var notifs_settings = $localStorage.getObject("notifs_settings", {
            noficationStatus: true,
            noficationStatus_weekStart: true,
            noficationStatus_gameStart: true,
            noficationStatus_gameEnd: true,
            noficationStatus_goals: true,
            noficationStatus_redCard: true,
            noficationStatus_yellowCard: true
          });
          console.log(notifs_settings);

          favoris_teams.forEach(function (favTeamId) {
            // unsubsribe from all
            // window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_GAME_START');
            // window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_GAME_START_AR');
            // window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_GAME_END');
            // window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_GAME_END_AR');
            // window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_GOAL');
            // window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_GOAL_AR');
            // window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_YELLOW_CARD');
            // window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_YELLOW_CARD_AR');
            // window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_RED_CARD_');
            // window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_RED_CARD_AR');
            // window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_RED_CARD_FR');

            // subscribe again
            if (favTeamId != '') {// valid team Id
              //check if FirebasePlugin tech is available
              if (window.FirebasePlugin) {
                if (notifs_settings.noficationStatus_gameStart)
                  window.FirebasePlugin.subscribe(TopicFlag + "TEAM_" + favTeamId + '_GAME_START' + $topic_lang_postfix);

                if (notifs_settings.noficationStatus_gameEnd)
                  window.FirebasePlugin.subscribe(TopicFlag + "TEAM_" + favTeamId + '_GAME_END' + $topic_lang_postfix);

                if (notifs_settings.noficationStatus_goals)
                  window.FirebasePlugin.subscribe(TopicFlag + "TEAM_" + favTeamId + '_GOAL' + $topic_lang_postfix);

                if (notifs_settings.noficationStatus_yellowCard) { window.FirebasePlugin.subscribe(TopicFlag + "TEAM_" + favTeamId + '_YELLOW_CARD' + $topic_lang_postfix); }

                if (notifs_settings.noficationStatus_redCard)
                  window.FirebasePlugin.subscribe(TopicFlag + "TEAM_" + favTeamId + '_RED_CARD' + $topic_lang_postfix);

              }
            }
          });

          $localStorage.set("FIREBASE_REGISTRED_TOPICS_V8", true);

        }, function (error) {
          console.error(error);
        });

        window.FirebasePlugin.onTokenRefresh(function (token) {
          // save this server-side and use it to push notifications to this device
          console.log('token');
          console.log(token);
        }, function (error) {
          console.error(error);
        });
      }
      // }
    }


    $rootScope._InitHome(true);
    setTimeout(function () {
      $scope._InitFirebase();
    }, 5000);


    // console.log(window.StreamingMediaIMA.coolMethod('test'));
    // window.StreamingMediaIMA.coolMethod('test').then(function(value) {
    //   console.log(value);
    // });

    //   var videoUrl = "http://cdnamd-hls-globecast.akamaized.net/live/ramdisk/arriadia/hls_snrt/index.m3u8";

    //   var successCallback = function(json) {
    //   };

    //   var errorCallback = function(error) {
    //   };

    //   var params = {
    //     url: videoUrl,
    //     userAgent: 'MyAwesomePlayer', // default is 'ExoPlayerPlugin'
    //     aspectRatio: 'FILL_SCREEN', // default is FIT_SCREEN
    //     hideTimeout: 5000, // Hide controls after this many milliseconds, default is 5 sec
    //     autoPlay: true, // When set to false stream will not automatically start
    //     seekTo: 10 * 60 * 60 * 1000, // Start playback 10 minutes into video specified in ms, default is 0
    //     forwardTime: 60 * 1000, // Amount of time in ms to use when skipping forward, default is 1 min
    //     rewindTime: 60 * 1000, // Amount of time in ms to use when skipping backward, default is 1 min
    //     audioOnly: true, // Only play audio in the backgroud, default is false
    //     subtitleUrl: 'http://url.to/subtitle.srt', // Optional subtitle url
    //     connectTimeout: 1000, // http connect timeout in ms (default is 0)
    //     readTimeout: 1000, // http read timeout in ms (default is 0)
    //     retryCount: 5, // Number of times datasource will retry the stream before giving up (default is 3)
    //     showBuffering: true, // When buffering, player will show indicator at the top of the screen, default is false
    //     controller: { // If this object is not present controller will not be visible
    //         streamImage: 'http://url.to/channel.png',
    //         streamTitle: 'Cool channel / movie',
    //         streamDescription: '2nd line you can use to display whatever you want like current program epg or movie description',
    //         hideProgress: true, // Hide entire progress timebar
    //         hidePosition: false, // If timebar is visible hide current position from it
    //         hideDuration: false, // If timebar is visible Hide stream duration from it
    //         controlIcons: {
    //             'exo_rew': null, // Set to null to remove the button from the player
    //             'exo_play': 'http://url.to/play.png',
    //             'exo_pause': 'http://url.to/pause.png',
    //             //'exo_ffwd': null, // Buttons not included in configuration will show up as default ExoPlayer buttons
    //         },
    //         textColor: '#ffff0000', // These colors can be any valid Android color
    //         buttonsColor: '#ff00ff00', // This example uses hex values including alpha (first byte)
    //         bufferingColor: '#ff0000ff' // Alpha of 'ff' makes it 100% opaque
    //     }
    // }

    // window.ExoPlayer.show(parameters, successCallback, errorCallback);

    // Just play a video
    // window.plugins.streamingMedia.playVideo(videoUrl);

    // // Play a video with callbacks
    // var options = {
    //   successCallback: function() {
    //     console.log("Video was closed without error.");
    //   },
    //   errorCallback: function(errMsg) {
    //     console.log("Error! " + errMsg);
    //   },
    //   orientation: 'landscape',
    //   shouldAutoClose: true,  // true(default)/false
    //   controls: true // true(default)/false. Used to hide controls on fullscreen
    // };
    // window.plugins.streamingMedia.playVideo(videoUrl, options);


    $scope.$on("$ionicView.enter", function () {
      // locOrientation = screen.lockOrientation || screen.mozLockOrientation || screen.msLockOrientation || screen.orientation.lock;
      // locOrientation('portrait');
      //Edit status bar color
      //if (window.StatusBar) window.StatusBar.backgroundColorByHexString('#08ae3c');
      if ($scope.slider) $scope.slider.startAutoplay();
    });

  });
