angular.module('starter')

	.controller('JourneeCtrl', function ($scope, $rootScope, $window, $http, $LoadingSpinner, $state, $PrintAlert, $cordovaGoogleAnalytics, $timeout) {

		//Check if the previous saison is requested
		$scope.CheckPreviousSaison = function () {
			if ($state.current.name.includes("app.menu")) {
				$rootScope.saisonId = null;
			}
			else {
				// $rootScope.saisonId = $rootScope.oldSaison;
			}
		}

		$scope.CheckPreviousSaison();

		$scope.goBacktoCurrentsaison = function () {
			$rootScope.saisonId = null;
			//Go to journee
			$state.go('app.menu.journee', null, { reload: true });
		}

		$scope.$on('$ionicView.beforeEnter', function (event, viewData) {
			viewData.enableBack = false;
			$rootScope._InitJournee($rootScope.CurrentJourney);
		});

		$scope.MatchDetail = function (match) {
			$rootScope.match = match;
			$rootScope.FilesPath = $scope.data.FilesPath;
			$state.go('app.match-detail.composition', { id: $rootScope.match.id });
		}

		$rootScope._InitJournee = function (journey) {
			$scope.data = {};
			$LoadingSpinner.Show();

			//Check if journey paramter is available		
			if (journey == undefined) journey = 0;
			if (journey == 0) params = {};
			else params = { journey: journey };

			//Check if saison dates are available
			if ($rootScope.saisonId) params.saisonId = $rootScope.saisonId;

			var req = {
				method: "GET",
				url: $rootScope.HOST + "Calendrier/index.php",
				params: params,
			};

			$http(req).then(function (res) {
				$scope.data = res.data;
				console.log(res.data);
				$rootScope.CurrentJourney = res.data.journey + '';
				$scope.data.journey = res.data.journey + '';
				$rootScope.ServerCurrentJourney = parseInt(res.data.current_journey);
				//broadcast refresh end
				$scope.$broadcast('scroll.refreshComplete');
				//hide spinner
				$LoadingSpinner.Hide();
				//if window 
				if (window.FirebasePlugin) window.FirebasePlugin.setScreenName("Journées");
			},
				function (error) {
					console.log("Error Occured: " + error);
					//broadcast refresh end
					$scope.$broadcast('scroll.refreshComplete');
					//hide spinner
					$LoadingSpinner.Hide();
				});
		}

		$scope.Detail = function (item) {
			$rootScope.item = item;
			$state.go('app.media-detail', { id: $rootScope.item.id, type: $rootScope.item.type, program: $rootScope.item.program_id, match: $rootScope.item.match_id });
		}

		$scope.NextJourney = function () {
			// && $scope.data.journey < $scope.ServerCurrentJourney
			if ($scope.data.journey != 30)
				$scope._InitJournee(parseInt($scope.data.journey) + 1);
		}

		$scope.PreviousJourney = function () {
			$scope._InitJournee(parseInt($scope.data.journey) - 1);
		}

		$scope.UpdatJourney = function () {
			$scope._InitJournee(parseInt($scope.data.journey));
		}


		$scope.InitJourneyAds = function () {
			//check if home tags are already displayed
			if (window['journey_tags']) window['googletag'].pubads().refresh([window['gptAdSlots'][2]]);
			else {
				window['journey_tags'] = true;
				window['googletag'].cmd.push(function () {
					window['googletag'].display('div-gpt-ad-1515432416448-2');
					window['googletag'].pubads().refresh([window['gptAdSlots'][2]]);
				});
			}
		}

		$scope.InitNativeAds = function () {
			$timeout(function () {
				if (typeof admob != "undefined") {
					console.log(admob);
					console.log('Admob is ready!');
					$scope.StartNativeAds();
				}
				else {
					// console.log('Wait for another 1s');
					$scope.InitNativeAds();
				}
			}, 1000);
		}


		$scope.StartNativeAds = function () {
			// display smart banner at bottom center, using the default options
			//Clear old banner if any
			admob.banner.remove()
			//Config banner id
			admob.banner.config({
				id: admobid.resultatBanner,
			});
			// Create banner
			admob.banner.prepare();
			// Show the banner
			admob.banner.show();
		}

		$scope.InitNativeAds();
		$scope.InitJourneyAds();

		//   $scope.$on("$ionicView.afterEnter", function(){
		// locOrientation = screen.lockOrientation || screen.mozLockOrientation || screen.msLockOrientation || screen.orientation.lock;
		// locOrientation('portrait');

		//$scope._InitJournee()
		//Edit status bar color
		//if(window.StatusBar) window.StatusBar.backgroundColorByHexString('#dc2127');
		// });

	});
