angular.module('starter')

  .controller('ArticlesCtrl', function ($scope, $rootScope, $http, $LoadingSpinner, $state, $cordovaGoogleAnalytics, $timeout) {
    $scope.$on("$ionicView.beforeEnter", function (event, data) {
      // register back view
      $rootScope.history.add($rootScope.$previousState, $state.current);
      data.enableBack = true;
      if ($scope.slider) $scope.slider.startAutoplay();
    });

    //Init offset & limit
    $scope.nextSlotId = 1;
    $scope.offset = 0;
    $scope.limit = 4;
    $scope.articles = null;

    $scope.switchRight = function () {
      if ($scope.current_lang == 'fr') $scope.slider.slideNext();
      else $scope.slider.slidePrev();
    }

    $scope.switchLeft = function () {
      if ($scope.current_lang == 'fr') $scope.slider.slidePrev();
      else $scope.slider.slideNext();
    }

    $scope.slider_options = {
      loop: true,
      autoplay: 3000
    }

    // $scope.$on("$ionicSlides.sliderInitialized", function (event, data) {
    //   // data.slider is the instance of Swiper
    //   $scope.slider = data.slider;
    //   console.log(data);
    // });

    $scope.$on("$ionicSlides.slideChangeEnd", function (event, data) {
      // note: the indexes are 0-based
      $scope.slider.startAutoplay();
    });

    $scope.Detail = function (item) {
      $rootScope.item = item;
      $state.go('app.media-detail', { id: $rootScope.item.id, type: $rootScope.item.type, program: $rootScope.item.program_id, match: $rootScope.item.match_id });
    }

    generateNextSlotName = function () {
      var id = $scope.nextSlotId++;
      return 'News-adslot' + id;
    }

    function insertAfter(el, referenceNode) {
      referenceNode.parentNode.insertBefore(el, referenceNode.nextSibling);
    }

    $rootScope._InitArticles = function (offset, limit) {
      // $LoadingSpinner.Show();
      //ajust limit
      if (offset == 0) limit = 8;

      var req = {
        method: "GET",
        url: $rootScope.HOST + "Articles/LoadMore.php",
        params: { offset: offset, limit: limit },
      };
      $http(req).then(function (res) {
        console.log(res.data);
        if (res) {
          if($scope.articles) $scope.articles = $scope.articles.concat(res.data.articles);
          else $scope.articles = res.data.articles;

          //Load news ads after receiving data => then render ng-if closers
          if (offset == 0) $scope.InitNewsAds();

          //Check if this is not the first request
          if (offset > 6 && offset < 15) {
            //We can init infinit scroll ad
            // Generate next slot name
            var slotName = generateNextSlotName();

            // Create a div for the slot
            var slotDiv = document.createElement('div');
            slotDiv.id = slotName; // Id must be the same as slotName

            //Get last article element
            var someElementsItems = document.querySelectorAll(".news .cmp-5.article");

            insertAfter(slotDiv, someElementsItems[someElementsItems.length - 1]);

            if (offset < 12) adtag = '/21671680130/BOTOLA/BOTOLA_App_Pave_Innread_News2';
            else adtag = '/21671680130/BOTOLA/BOTOLA_App_Pave_Innread_News3';

            //Push ad
            window['googletag'].cmd.push(function () {
              var slot = window['googletag'].defineSlot(adtag, [[300, 250], [336, 280], [320, 100]], slotName).
                addService(window['googletag'].pubads());

              // Display has to be called before
              // refresh and after the slot div is in the page.
              window['googletag'].display(slotName);
              window['googletag'].pubads().refresh([slot]);
            });
          }

          //increase offset
          $scope.offset = $scope.offset + res.data.articles.length;

          if (res.data.articles.length == 0) $scope.HideSpinner = true;
        }

        $scope.loading = false;
        //broadcast refresh end
        $scope.$broadcast('scroll.refreshComplete');
        $scope.$broadcast('scroll.infiniteScrollComplete');
        //hide spinner
        // $LoadingSpinner.Hide();

      },
        function (error) {
          console.log("Error Occured: ");
          console.log(error);
          $scope.loading = false;
          //broadcast refresh end
          $scope.$broadcast('scroll.refreshComplete');
          $scope.$broadcast('scroll.infiniteScrollComplete');
          //hide spinner
          // $LoadingSpinner.Hide();
        });
    }

    $scope.InitNewsAds = function () {
      //check if home tags are already displayed
      if (window['news_tags']) {
        window['googletag'].pubads().refresh([window['gptAdSlots'][1]]);
      }
      else {
        window['news_tags'] = true;
        window['googletag'].cmd.push(function () {
          window['googletag'].display('div-gpt-ad-1515432416448-1');
          window['googletag'].pubads().refresh([window['gptAdSlots'][1]]);
        });
      }
    }

    $scope.InitNativeAds = function () {
      $timeout(function () {
        if (typeof admob != "undefined") {
          console.log(admob);
          console.log('Admob is ready!');
          $scope.StartNativeAds();
        }
        else {
          // console.log('Wait for another 1s');
          $scope.InitNativeAds();
        }
      }, 1000);
    }


    $scope.StartNativeAds = function () {
      // display smart banner at bottom center, using the default options
      //Clear old banner if any
      admob.banner.remove()
      //Config banner id
      admob.banner.config({
        id: admobid.newsBanner,
      });
      // Create banner
      admob.banner.prepare();
      // Show the banner
      admob.banner.show();
    }

    $scope.InitNativeAds();



  });
