angular.module('starter')

  .controller('SelectFavorisCtrl', function ($scope, $rootScope, $LoadingSpinner, $http, $state, $cordovaGoogleAnalytics, $timeout, $ionicPlatform, $localStorage) {

    $scope.$on('$ionicView.beforeEnter', function () {
      
    });

    $scope.$on('$ionicView.afterEnter', function () {
      $scope._InitFavorites();
      //Update changed session flag
      $scope.changeSession = $state.params.changeSession;
      
      $scope.favCounter = 0;
      $scope.notAppInit = $localStorage.get("no_app_init", true);
    });

    $scope._loadNotificationsStatus = function () {
      //get notif paramters
      $scope.notifs_settings = $localStorage.getObject("notifs_settings", {
        noficationStatus: true,
        noficationStatus_weekStart: true,
        noficationStatus_gameStart: true,
        noficationStatus_gameEnd: true,
        noficationStatus_goals: true,
        noficationStatus_redCard: true,
        noficationStatus_yellowCard: true
      });
    }

    /**
     * Summary. Init favorites 
     */
    $scope._InitFavorites = function () {
      $scope._loadNotificationsStatus();

      //Get local favorite teams
      $scope.favteam = localStorage['fav-team'];
      var favoris_teams;

      if ($scope.favteam != undefined) {
        favoris_teams = $scope.favteam.split(';');

        //Check if saison has changed => Unsubscribe all old teams
        if ($scope.changeSession) {
          favoris_teams.forEach(function (favTeamId) {
            //Unsubscribe team
            $scope.unsubscribe(favTeamId, TopicFlag);
          });
        }
      }

      console.log("OLD TEAMS", favoris_teams);
      $scope.data = {};
      $LoadingSpinner.Show();
      var req = {
        method: "GET",
        url: MHOST + "Teams/?favteam=" + $scope.favteam
      };
      $http(req).then(function (res) {
        console.log(res.data);
        $scope.data = res.data;
        
        //Check if the returned fevteam is not empty => Update fav teams
        if (res.data.favteam) {
          //Update local fav teams
          localStorage['fav-team'] = res.data.favteam;
          $scope.favteam = res.data.favteam;

          //Update fav teams array
          favoris_teams = $scope.favteam.split(';');

          console.log("NEW TEAMS", favoris_teams);

        }

        // show only Botola Teams on the fav-select view
        // @FIXME might be better if done at backend (type and request the wanted teams type ####
        // just one in hurry :/
        var tmpArray = [];
        res.data.teams.forEach(function (team, idx) {
          if (team.type == 'BOTOLA') tmpArray.push(team);
        });
        res.data.teams = tmpArray;

        //Copy local favorits
        if (favoris_teams != undefined) {
          favoris_teams.forEach(function (local_team) {
            res.data.teams.forEach(function (team) {
              if (local_team == team.id) team.fav = true;
            });
          });
        }

        //Check if saison has changed => then we need to clear out old subscriptions & make new ones
        if ($scope.changeSession) {
          //Reset subscription
          $scope._InitSubscription();
        }

        $LoadingSpinner.Hide();

        //check if FirebasePlugin tech is available
        if (window.FirebasePlugin) window.FirebasePlugin.setScreenName("Choix équipes favorites");
      },
        function (error) {
          console.log("Error Occured: ");
          console.log(error);
          $LoadingSpinner.Hide();
        });
    }

    /**
     * Summary. Init subscriptions
     */
    $scope._InitSubscription = function () {
      //Init str
      var str = "";
      //Get settings
      var notifs_settings = $localStorage.getObject("notifs_settings", {
        noficationStatus: true,
        noficationStatus_weekStart: true,
        noficationStatus_gameStart: true,
        noficationStatus_gameEnd: true,
        noficationStatus_goals: true,
        noficationStatus_redCard: true,
        noficationStatus_yellowCard: true
      });

      $topic_lang_postfix = ($rootScope.current_lang == 'ar') ? '_AR' : '';

      success = function () { console.log('SUBSCRIBE SUCCESS'); }
      failed = function () { console.log('SUBSCRIBE FAILED'); }

      //Check if FirebasePlugin tech is available
      if (window.FirebasePlugin) {
      $scope.data.teams.forEach(function (team) {
        if (team.fav) {
          str += team.id + ";";
          var favTeamId = team.id;
          if (notifs_settings.noficationStatus_gameStart)
            window.FirebasePlugin.subscribe(TopicFlag + "TEAM_" + favTeamId + '_GAME_START' + $topic_lang_postfix, success, failed);

          if (notifs_settings.noficationStatus_gameEnd)
            window.FirebasePlugin.subscribe(TopicFlag + "TEAM_" + favTeamId + '_GAME_END' + $topic_lang_postfix, success, failed);

          if (notifs_settings.noficationStatus_goals)
            window.FirebasePlugin.subscribe(TopicFlag + "TEAM_" + favTeamId + '_GOAL' + $topic_lang_postfix, success, failed);

          if (notifs_settings.noficationStatus_yellowCard) {
            window.FirebasePlugin.subscribe(TopicFlag + "TEAM_" + favTeamId + '_YELLOW_CARD' + $topic_lang_postfix, success, failed);
          }

          if (notifs_settings.noficationStatus_redCard)
            window.FirebasePlugin.subscribe(TopicFlag + "TEAM_" + favTeamId + '_RED_CARD' + $topic_lang_postfix, success, failed);
        }
        else {
          $scope.unsubscribe(favTeamId, TopicFlag);
        }
      });
      }
      $rootScope.favoris_teams = str.split(';');

      localStorage['fav-team'] = str;
    }

    /**
     * Summary. Unsubscribe team
     * @param {*} favTeamId 
     * @param {*} TopicFlag 
     */
    $scope.unsubscribe = function (favTeamId, TopicFlag) {
      if (window.FirebasePlugin) {
        window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_GAME_START');
        window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_GAME_START_AR');
        window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_GAME_END');
        window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_GAME_END_AR');
        window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_GOAL');
        window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_GOAL_AR');
        window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_YELLOW_CARD');
        window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_YELLOW_CARD_AR');
        window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_RED_CARD_');
        window.FirebasePlugin.unsubscribe(TopicFlag + "TEAM_" + favTeamId + '_RED_CARD_AR');
      }

    }

    /**
     * Summary. select favorite team
     * @param {*} team 
     */
    $scope.selectFavorite = function (team) {
      if (team.fav) {
        team.fav = false;
        if (($scope.notAppInit == true) && ($scope.favCounter > 0)) {
          $scope.favCounter--;
        }
      } else {
        team.fav = true;
        $scope.favCounter++;
      }

    }

    /**
     * Summary. Validate favoris
     */
    $scope.validateFavoris = function () {
      //Start spinner
      $LoadingSpinner.Show();

      //Ini subscription
      $scope._InitSubscription();

      $localStorage.set("fav_not_set", false);
      $localStorage.set("no_app_init", false);

      //hide spinner
      $LoadingSpinner.Hide();

      //Redirect to home ui
      $state.go('app.menu.home');
    }


    $scope.later = function () {
      // reset all to not fav
      $scope.data.teams.forEach(function (team) {
        if (team.fav) {
          team.fav = false;
          $scope.favCounter--;
        }
      });

      $state.go('app.menu.home');
    }

  });
