angular.module('starter.services', [])

.factory('$localStorage', ['$window', function($window) {
  return {
    set: function(key, value) {
      $window.localStorage[key] = value;
    },
    get: function(key, defaultValue) {
		if($window.localStorage[key] == 'undefined' ||$window.localStorage[key] == undefined  ) res = defaultValue;
		else res = $window.localStorage[key] ;
      return res;
    },
    setObject: function(key, value) {
      $window.localStorage[key] = JSON.stringify(value);
    },
    getObject: function(key, value) {
      return $window.localStorage[key] ? JSON.parse($window.localStorage[key]) : value;
    },
	getAll: function() {
      return $window.localStorage;
    },
	 removeItem: function(key){
     $window.localStorage.removeItem(key);
    }
  }
}])
.factory('$Request', ['$http','$LoadingSpinner', function($http, $LoadingSpinner) {
  return {
    get: function(url, method, data) {
		$LoadingSpinner.Show();
		var req = {
			method: method,
			url: url,
			data: data,
		};
		result = {};
			
		$http(req).then(function(res){
			result.status = true;
			result.data = res.data;
			$LoadingSpinner.Hide();
			return result;
		}, 
		function(error){
			result.status = false;
			console.log("Error Occured: "+error);
			$LoadingSpinner.Hide();
			return result;
		});

    },
	GetLastSync: function(type){
	//	console.log("Last Check: "+$window.localStorage[type+'-LastCheck']);
		Fulldate = $window.localStorage[type+'-LastCheck'];
		if(Fulldate==null) return null;
		else {
			date = new Date(Fulldate);
			dateStr = date.toDateString()+ " " + date.getHours() + ":" + date.getMinutes();
			return dateStr;
		}
	},
	 CheckSyncPageParserDetail: function(PageParserID) {
		 
		var PageParserDetail = $window.localStorage[PageParserID+"-PageParserDetail"];
					 if(PageParserDetail !=null && PageParserDetail != "")	{
						return true;
					 }
					 else return false;
    }
  }
}])

 .factory('$LoadingSpinner', ['$ionicLoading', function($ionicLoading) {
  return {
    Show: function() {
    		 // custom loader  
		 //$ionicLoading.show({template: "<img src='img/loader.gif'>"});

		 // default ionic loader
		 $ionicLoading.show();
    },
	Hide: function() {
		 $ionicLoading.hide();
    }
  }
}]) 
 .factory('$PrintAlert', ['$ionicPopup', function($ionicPopup) {
  return {
    Show: function(title, mssg) {
				 var alertPopup = $ionicPopup.alert({
							 title: title,
							 template: mssg
						   });
			return alertPopup;
    }
  }
}])

 .factory('$Tools', [function() {
  return {
    Shuffle: function(array) {
				
			var currentIndex = array.length, temporaryValue, randomIndex;
			  // While there remain elements to shuffle...
			  while (0 !== currentIndex) {

				// Pick a remaining element...
				randomIndex = Math.floor(Math.random() * currentIndex);
				currentIndex -= 1;

				// And swap it with the current element.
				temporaryValue = array[currentIndex];
				array[currentIndex] = array[randomIndex];
				array[randomIndex] = temporaryValue;
			  }

			  return array;
    }
  }
}])
.factory('$UserAuth', ['$window', function($window) {
  return {
    Check: function() {
		if($window.localStorage['usr_id'] != null && $window.localStorage['usr_id'] !="" && $window.localStorage['usr_id'] != "undefined"){
				//console.log("$window.localStorage['usr_id']: "+$window.localStorage['usr_id']);
				return true;
		}
		else return false;

    },
	setUser: function(obj){
		console.log("user saving: "+obj.userID);
		$window.localStorage['usr_id'] = obj.userID;
		$window.localStorage['usr_name'] = obj.name;
		$window.localStorage['usr_email'] = obj.email;
		$window.localStorage['usr_picture'] = obj.picture;
		$window.localStorage['accessToken'] = obj.accessToken;
		$window.localStorage['idToken'] = obj.idToken;
	},
	getUserId: function(){
		if($window.localStorage['usr_id'] != null && $window.localStorage['usr_id'] !="" && $window.localStorage['usr_id'] != "undefined"){
				return $window.localStorage['usr_id'];
		}
		else return false;
	},
	getUser: function(){
		User = {};
		User.usr_id = $window.localStorage['usr_id'];
		User.usr_name = $window.localStorage['usr_name'];
		User.usr_email = $window.localStorage['usr_email'];
		User.usr_picture = $window.localStorage['usr_picture'];
		return User;
	},
	removeCurrentUser: function(){
		localStorage.removeItem('usr_id');
		localStorage.removeItem('usr_name');
		localStorage.removeItem('usr_email');
		localStorage.removeItem('usr_picture');
		localStorage.removeItem('accessToken');
		localStorage.removeItem('idToken');
	},
	GetLastSync: function(){
		console.log("Last Check: "+$window.localStorage['LastCheck']);
		Fulldate = $window.localStorage['LastCheck'];
		if(Fulldate==null) return false;
		else {
			date = new Date(Fulldate);
			dateStr = date.toDateString()+ " " + date.getHours() + ":" + date.getMinutes();
			return dateStr;
		}
	},
	GetNewSync: function(){

			date = new Date();
			dateStr = date.toDateString()+ " " + date.getHours() + ":" + date.getMinutes();
			$window.localStorage['LastCheck'] = dateStr;
			return dateStr;
	}

  }
}])  
;
