angular.module('starter')

.controller('SettingsCtrl', function($scope, $rootScope, $window, $http, $ionicModal, $timeout, $sce, $ionicPopup, $localStorage, $LoadingSpinner, $translate, $state, $ionicHistory) {
  
  $scope.$on("$ionicView.beforeEnter", function(event, data) {
    // register back view
    $rootScope.history.add($rootScope.$previousState, $state.current);

    data.enableBack = true;

    //locOrientation = screen.lockOrientation || screen.mozLockOrientation || screen.msLockOrientation || screen.orientation.lock;
    //locOrientation('portrait');

    // firebase stats
    if(window.FirebasePlugin)
      window.FirebasePlugin.setScreenName("Settings");

    //get notif paramters
    $scope.notifs_settings = $localStorage.getObject("notifs_settings", {
      noficationStatus: true,
      noficationStatus_weekStart: true,
      noficationStatus_gameStart: true,
      noficationStatus_gameEnd: true,
      noficationStatus_goals: true,
      noficationStatus_redCard: true,
      noficationStatus_yellowCard: true
    });

    if ($localStorage.get("isNotdLang", true) == "true") {
      $scope.isNotDefaultLang = true;
    } else {
      $scope.isNotDefaultLang = false;
    }
  });

  //Init Vals
  $scope.data = {};

  $scope.ChangeStatus = function(param ) {
    
    $scope.saveSettings();
  }

  $scope.getFavTeams = function(){
    var favteam = localStorage['fav-team'];
    $scope.favoris_teams = null;
    if (favteam != undefined){
       $scope.favoris_teams = favteam.split(';');
    }
  }

   $scope.saveSettings = function() {
    // set FIREBASE_REGISTRED_TOPICS to false so that when the app starts up the firebase topics subscriptions would be updated
    $localStorage.set("FIREBASE_REGISTRED_TOPICS", false);

    // handle global notifications subscription
    // if($scope.notifs_settings.noficationStatus_weekStart)
    //   window.FirebasePlugin.subscribe("ALL");
    // else
    //   window.FirebasePlugin.unsubscribe("ALL");

    // handle pereferred teams notifications
    $scope.getFavTeams();
    if($scope.favoris_teams){
      //start spinner
      $LoadingSpinner.Show();

      $topic_lang_postfix = ($rootScope.current_lang=='ar')?'_AR':'';

      $scope.favoris_teams.forEach(function(favTeamId) {
          // unsubsribe from all
          window.FirebasePlugin.unsubscribe("TEAM_" +favTeamId + '_GAME_START_AR');
          window.FirebasePlugin.unsubscribe("TEAM_" +favTeamId + '_GAME_START');
          window.FirebasePlugin.unsubscribe("TEAM_" +favTeamId + '_GAME_END_AR');
          window.FirebasePlugin.unsubscribe("TEAM_" +favTeamId + '_GAME_END');
          window.FirebasePlugin.unsubscribe("TEAM_" +favTeamId + '_GOAL_AR');
          window.FirebasePlugin.unsubscribe("TEAM_" +favTeamId + '_GOAL');
          window.FirebasePlugin.unsubscribe("TEAM_" +favTeamId + '_YELLOW_CARD_AR');
          window.FirebasePlugin.unsubscribe("TEAM_" +favTeamId + '_YELLOW_CARD');
          window.FirebasePlugin.unsubscribe("TEAM_" +favTeamId + '_RED_CARD_AR');
          window.FirebasePlugin.unsubscribe("TEAM_" +favTeamId + '_RED_CARD');

          // subscribe again
          if(favTeamId != ''){// valid team Id
            //check if FirebasePlugin tech is available
            if(window.FirebasePlugin) {
              if($scope.notifs_settings.noficationStatus_gameStart)
                window.FirebasePlugin.subscribe("TEAM_" +favTeamId + '_GAME_START' + $topic_lang_postfix);

              if($scope.notifs_settings.noficationStatus_gameEnd)
                window.FirebasePlugin.subscribe("TEAM_" +favTeamId + '_GAME_END' + $topic_lang_postfix);

              if($scope.notifs_settings.noficationStatus_goals)
                window.FirebasePlugin.subscribe("TEAM_" +favTeamId + '_GOAL' + $topic_lang_postfix);

              if($scope.notifs_settings.noficationStatus_yellowCard)
                window.FirebasePlugin.subscribe("TEAM_" +favTeamId + '_YELLOW_CARD' + $topic_lang_postfix);

              if($scope.notifs_settings.noficationStatus_redCard)
                window.FirebasePlugin.subscribe("TEAM_" +favTeamId + '_RED_CARD' + $topic_lang_postfix);
              
            }
          }
      });
        
      $LoadingSpinner.Hide();
    }

    

    console.log( $scope.notifs_settings);
    $localStorage.setObject("notifs_settings", $scope.notifs_settings);

    // $localStorage.set("noficationStatus_weekStart", $scope.noficationStatus_weekStart);
    // $localStorage.set("noficationStatus_gameStart", $scope.noficationStatus_gameStart);
    // $localStorage.set("noficationStatus_gameEnd", $scope.noficationStatus_gameEnd);
    // $localStorage.set("noficationStatus_goals", $scope.noficationStatus_goals);
    // $localStorage.set("noficationStatus_redCard", $scope.noficationStatus_redCard);
    // $localStorage.set("noficationStatus_yellowCard", $scope.noficationStatus_yellowCard);

    
  }

  $scope.ChangeLang = function(lang) {
    // QUICK FIX for menu ui bug at app language changing

    $localStorage.set("FIREBASE_REGISTRED_TOPICS", false);

    jQuery('ion-side-menu').css('display', 'none');

    $LoadingSpinner.Show();
    if (lang == 'ar') {
      $localStorage.set("isNotdLang", false);
      // $translate.use('ar');
      $rootScope.current_direction = "rtl";
      $rootScope.current_class = "right";
      $rootScope.current_lang= "ar";
    } else {
      $localStorage.set("isNotdLang", true);
      // $translate.use('fr');
      $rootScope.current_direction = "ltr";
      $rootScope.current_class = "left";
      $rootScope.current_lang= "fr";
    }

    
    $window.location.href = "#/app/menu/home";
    setTimeout(function() {

      //this reload apprently is mondatory to fix a sliding menu issu
      // $window.location.hash = "/#/app/menu/home";
      $window.location.reload();
      //$window.location.href = "#/app/menu/home";
      // window.location.reload();
      
      
    }, 500);
  };


  // $scope.data.refreshrate = $localStorage.get("RefreshRate",30);
  // if($localStorage.get("ArLang",true)=="true") $scope.data.ArLang = true;
  // else $scope.data.ArLang = false;
  // if($localStorage.get("FrLang",true)=="true") $scope.data.FrLang = true;
  // else $scope.data.FrLang = false;

  //Functions
  // $scope.setRefreshRate = function() {
  //  $localStorage.set("RefreshRate",$scope.data.refreshrate);
  //  }
  // $scope.ChangeArLang = function(){
  //  $localStorage.set("ArLang",$scope.data.ArLang);
  // }
  // $scope.ChangeFrLang = function(){
  //  $localStorage.set("FrLang",$scope.data.FrLang);
  // }

});
