(function() {
  'use strict';

  angular.module('starter')
    .directive('tabsSwipable', ['$ionicGesture', '$rootScope', function($ionicGesture, $rootScope) {
      //
      // make ionTabs swipable. leftswipe -> nextTab, rightswipe -> prevTab
      // Usage: just add this as an attribute in the ionTabs tag
      // <ion-tabs tabs-swipable> ... </ion-tabs>
      //
      return {
        restrict: 'A',
        require: 'ionTabs',
        link: function(scope, elm, attrs, tabsCtrl) {
          var onSwipeLeft = function(elm) {
            // console.log(elm.srcElement.className);
            //Check if it's a non swippable element
            if(elm.srcElement.className.includes('nswp')) return false;

            if ($rootScope.current_direction == "ltr") {
              var target = tabsCtrl.selectedIndex() + 1;
              if (target < tabsCtrl.tabs.length) {
                scope.$apply(tabsCtrl.select(target));
              } else {
                scope.$apply(tabsCtrl.select(0));
              }
            } else {
              var target = tabsCtrl.selectedIndex() - 1;
              if (target >= 0) {
                scope.$apply(tabsCtrl.select(target));
              } else {
                scope.$apply(tabsCtrl.select(tabsCtrl.tabs.length - 1));
              }
            }
          };
          var onSwipeRight = function(elm) {
            // console.log(elm.srcElement.className);
            //Check if it's a non swippable element
            if(elm.srcElement.className.includes('nswp')) return false;

            if ($rootScope.current_direction == "ltr") {
              var target = tabsCtrl.selectedIndex() - 1;
              if (target >= 0) {
                scope.$apply(tabsCtrl.select(target));
              } else {
                scope.$apply(tabsCtrl.select(tabsCtrl.tabs.length - 1));
              }
            } else {
              var target = tabsCtrl.selectedIndex() + 1;
              if (target < tabsCtrl.tabs.length) {
                scope.$apply(tabsCtrl.select(target));
              } else {
                scope.$apply(tabsCtrl.select(0));
              }
            }

          };

          var swipeGesture = $ionicGesture.on('swipeleft', onSwipeLeft, elm).on('swiperight', onSwipeRight);
          scope.$on('$destroy', function() {
            $ionicGesture.off(swipeGesture, 'swipeleft', onSwipeLeft);
            $ionicGesture.off(swipeGesture, 'swiperight', onSwipeRight);
          });
        }
      };
    }]);

})();
